package com.wadpam.open.dao;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.Filter;
import net.sf.mardao.core.dao.DaoImpl;
import net.sf.mardao.core.dao.TypeDaoImpl;
import net.sf.mardao.core.geo.DLocation;
import com.wadpam.open.domain.DAppAdmin;

/**
 * The DAppAdmin domain-object specific finders and methods go in this POJO.
 * 
 * Generated on 2013-07-09T14:34:34.876+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public class GeneratedDAppAdminDaoImpl extends TypeDaoImpl<DAppAdmin, java.lang.String> 
	implements GeneratedDAppAdminDao {


    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getBasicColumnNames() {
        return BASIC_NAMES;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getManyToOneColumnNames() {
        return MANY_TO_ONE_NAMES;
    }

    private final Map<String, DaoImpl> MANY_TO_ONE_DAOS = new TreeMap<String, DaoImpl>();

    /** Default constructor */
   public GeneratedDAppAdminDaoImpl() {
      super(DAppAdmin.class, java.lang.String.class);
   }

   // ------ BEGIN DaoImpl overrides -----------------------------
   
   public String getPrimaryKeyColumnName() {
   		return COLUMN_NAME_ADMINID;
   }
   
   public List<String> getColumnNames() {
        return COLUMN_NAMES;
   }

   @Override
   protected DaoImpl getManyToOneDao(String columnName) {
       return MANY_TO_ONE_DAOS.get(columnName);
   }

    @Override
    protected Object getDomainProperty(DAppAdmin domain, String name) {
        Object value;
        // simple key?
        if (COLUMN_NAME_ADMINID.equals(name)) {
            value = domain.getAdminId();
        }
        // fields
        else if (COLUMN_NAME_ACCOUNTSTATUS.equals(name)) {
            value = domain.getAccountStatus();
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            value = domain.getCreatedBy();
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            value = domain.getCreatedDate();
        }
        else if (COLUMN_NAME_EMAIL.equals(name)) {
            value = domain.getEmail();
        }
        else if (COLUMN_NAME_MAXNUMBEROFAPPS.equals(name)) {
            value = domain.getMaxNumberOfApps();
        }
        else if (COLUMN_NAME_NAME.equals(name)) {
            value = domain.getName();
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            value = domain.getUpdatedBy();
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            value = domain.getUpdatedDate();
        }
        // one-to-ones
        // many-to-ones
        // many-to-manys
        else {
            value = super.getDomainProperty(domain, name);
        }

        return value;
    }

    /**
     * Returns the class of the domain property for specified column
     * @param name
     * @return the class of the domain property
     */
    public Class getColumnClass(String name) {
        Class clazz;
        // simple key?
        if (COLUMN_NAME_ADMINID.equals(name)) {
            clazz = java.lang.String.class;
        }
        // fields
        else if (COLUMN_NAME_ACCOUNTSTATUS.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        else if (COLUMN_NAME_EMAIL.equals(name)) {
            clazz = com.google.appengine.api.datastore.Email.class;
        }
        else if (COLUMN_NAME_MAXNUMBEROFAPPS.equals(name)) {
            clazz = java.lang.Long.class;
        }
        else if (COLUMN_NAME_NAME.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        // one-to-ones
        // many-to-ones
        // many-to-manys
        else {
            throw new IllegalArgumentException("No such column " + name);
        }

        return clazz;
    }
      
    @Override
    protected void setDomainProperty(final DAppAdmin domain, final String name, final Object value) {
        // simple key?
        if (COLUMN_NAME_ADMINID.equals(name)) {
            domain.setAdminId((java.lang.String) value);
        }
        // fields
        else if (COLUMN_NAME_ACCOUNTSTATUS.equals(name)) {
            domain.setAccountStatus((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            domain.setCreatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            domain.setCreatedDate((java.util.Date) value);
        }
        else if (COLUMN_NAME_EMAIL.equals(name)) {
            domain.setEmail((com.google.appengine.api.datastore.Email) value);
        }
        else if (COLUMN_NAME_MAXNUMBEROFAPPS.equals(name)) {
            domain.setMaxNumberOfApps((java.lang.Long) value);
        }
        else if (COLUMN_NAME_NAME.equals(name)) {
            domain.setName((java.lang.String) value);
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            domain.setUpdatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            domain.setUpdatedDate((java.util.Date) value);
        }
        // one-to-ones
        // many-to-ones
        // many-to-manys
        else {
            super.setDomainProperty(domain, name, value);
        }
    }

    @Override
    protected void setDomainStringProperty(final DAppAdmin domain, final String name, final Map<String, String> properties) {
        final String value = properties.get(name);
        Class clazz = getColumnClass(name);
        // many-to-ones
        setDomainProperty(domain, name, parseProperty(value, clazz));
    }

    /**
     * Overrides to substitute Entity properties with foreign keys
     */
    @Override
    protected void setCoreProperty(Object core, String name, Object value) {
        if (null == core || null == name) {
            return;
        }
        else if (null == value) {
            // do nothing in particular, will call super at end
        }
        super.setCoreProperty(core, name, value);
    }

   // ------ END DaoImpl overrides -----------------------------

        // DAppAdmin has no parent

        /**
         * @return the simple key for specified DAppAdmin domain object
         */
        public String getSimpleKey(DAppAdmin domain) {
            if (null == domain) {
                return null;
            }
            return domain.getAdminId();
        }

        /**
         * @return the simple key for specified DAppAdmin domain object
         */
        public void setSimpleKey(DAppAdmin domain, String adminId) {
            domain.setAdminId(adminId);
        }

        public String getCreatedByColumnName() {
            return COLUMN_NAME_CREATEDBY;
        }

        public String getCreatedBy(DAppAdmin domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedBy();
        }

        public void _setCreatedBy(DAppAdmin domain, String creator) {
            domain.setCreatedBy(creator);
        }

        public String getUpdatedByColumnName() {
            return COLUMN_NAME_UPDATEDBY;
        }

        public String getUpdatedBy(DAppAdmin domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedBy();
        }

        public void _setUpdatedBy(DAppAdmin domain, String updator) {
            domain.setUpdatedBy(updator);
        }

        public String getCreatedDateColumnName() {
            return COLUMN_NAME_CREATEDDATE;
        }

        public Date getCreatedDate(DAppAdmin domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedDate();
        }

        public void _setCreatedDate(DAppAdmin domain, Date date) {
            domain.setCreatedDate(date);
        }

        public String getUpdatedDateColumnName() {
            return COLUMN_NAME_UPDATEDDATE;
        }

        public Date getUpdatedDate(DAppAdmin domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedDate();
        }

        public void _setUpdatedDate(DAppAdmin domain, Date date) {
            domain.setUpdatedDate(date);
        }

	// ----------------------- field finders -------------------------------
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByAccountStatus(java.lang.String accountStatus) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ACCOUNTSTATUS, accountStatus);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field accountStatus
	 * @param accountStatus the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByAccountStatus(java.lang.String accountStatus) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ACCOUNTSTATUS, accountStatus);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field accountStatus
	 * @param accountStatus the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified accountStatus
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByAccountStatus(java.lang.String accountStatus,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ACCOUNTSTATUS, accountStatus);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified createdBy
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified createdDate
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
	 * find-by method for unique attribute field email
	 * @param email the unique attribute
	 * @return the unique DAppAdmin for the specified attribute
	 */
	public final DAppAdmin findByEmail(com.google.appengine.api.datastore.Email email) {
                Filter filter = createEqualsFilter(COLUMN_NAME_EMAIL, email);
		return findUniqueBy(filter);
	}

	/**
	 * find-key-by method for unique attribute field email
	 * @param email the unique attribute
	 * @return the unique DAppAdmin for the specified attribute
	 */
	public final java.lang.String findKeyByEmail(com.google.appengine.api.datastore.Email email) {
                Filter filter = createEqualsFilter(COLUMN_NAME_EMAIL, email);
		return findUniqueKeyBy(filter);
	}
	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByMaxNumberOfApps(java.lang.Long maxNumberOfApps) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_MAXNUMBEROFAPPS, maxNumberOfApps);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field maxNumberOfApps
	 * @param maxNumberOfApps the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByMaxNumberOfApps(java.lang.Long maxNumberOfApps) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_MAXNUMBEROFAPPS, maxNumberOfApps);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field maxNumberOfApps
	 * @param maxNumberOfApps the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified maxNumberOfApps
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByMaxNumberOfApps(java.lang.Long maxNumberOfApps,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_MAXNUMBEROFAPPS, maxNumberOfApps);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByName(java.lang.String name) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_NAME, name);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field name
	 * @param name the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByName(java.lang.String name) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_NAME, name);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field name
	 * @param name the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified name
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByName(java.lang.String name,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_NAME, name);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified updatedBy
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAppAdmin> queryByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of keys to the DAppAdmins with the specified attribute
	 */
	public final Iterable<java.lang.String> queryKeysByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAppAdmins for the specified updatedDate
	 */
	public final CursorPage<DAppAdmin, java.lang.String> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------

	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------

	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	public DAppAdmin persist(		java.lang.String adminId, 
		java.lang.String accountStatus, 
		com.google.appengine.api.datastore.Email email, 
		java.lang.Long maxNumberOfApps, 
		java.lang.String name) {

            DAppAdmin domain = null;
            // if primaryKey specified, use it
            if (null != adminId) {
                    domain = findByPrimaryKey(adminId);
            }
		
            // create new?
            if (null == domain) {
                    domain = new DAppAdmin();
                    // generate Id?
                    if (null != adminId) {
                            domain.setAdminId(adminId);
                    }
                    // fields
                    domain.setAccountStatus(accountStatus);
                    domain.setEmail(email);
                    domain.setMaxNumberOfApps(maxNumberOfApps);
                    domain.setName(name);
                    // one-to-ones
                    // many-to-ones
			
                    persist(domain);
            }
            return domain;
	}


	/**
	 * Persists an entity unless it already exists
	 */
	public DAppAdmin persist(com.google.appengine.api.datastore.Email email, 
                java.lang.String accountStatus, 
                java.lang.Long maxNumberOfApps, 
                java.lang.String name) {
            DAppAdmin domain = findByEmail(email);
            if (null == domain) {
                domain = new DAppAdmin();
                domain.setAccountStatus(accountStatus);
                domain.setEmail(email);
                domain.setMaxNumberOfApps(maxNumberOfApps);
                domain.setName(name);
                persist(domain);
            }
            return domain;
	}


}
